Index: pjproject/trunk/pjmedia/include/pjmedia-codec/ffmpeg_codecs.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/ffmpeg_codecs.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/ffmpeg_codecs.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/include/pjmedia-codec/h263_packetizer.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-codec/h263_packetizer.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-codec/h263_packetizer.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia-videodev/config.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-videodev/config.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-videodev/config.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia-videodev/errno.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-videodev/errno.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-videodev/errno.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev_imp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev_imp.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia-videodev/videodev_imp.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia/avi.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/avi.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/avi.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia/avi_stream.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/avi_stream.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/avi_stream.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia/format.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/format.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/format.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/frame.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/frame.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/frame.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/vid_codec.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/vid_codec.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/vid_codec.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/vid_codec_util.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/vid_codec_util.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/vid_codec_util.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/include/pjmedia/vid_port.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/vid_port.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia/vid_port.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/include/pjmedia_videodev.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia_videodev.h	(revision 3714)
+++ pjproject/trunk/pjmedia/include/pjmedia_videodev.h	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_codecs.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_codecs.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/ffmpeg_codecs.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2010-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/h263_packetizer.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/dshow_dev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/dshowclasses.cpp
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/dshowclasses.cpp	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/dshowclasses.cpp	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/errno.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/errno.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/errno.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/ffmpeg_dev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/ios_dev.m
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/ios_dev.m	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/ios_dev.m	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/sdl_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/sdl_dev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/sdl_dev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/v4l2_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/v4l2_dev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/v4l2_dev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/videodev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/videodev.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/videodev.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia/avi_player.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/pjmedia/dummy.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/dummy.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/dummy.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/pjmedia/format.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/format.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/format.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/pjmedia/types.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/types.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/types.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_codec.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_codec.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_codec.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_port.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_port.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2010 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/trunk/pjmedia/src/test/vid_codec_test.c
===================================================================
--- pjproject/trunk/pjmedia/src/test/vid_codec_test.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/test/vid_codec_test.c	(revision 3715)
@@ -1,2 +1,20 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
 #include "test.h"
 #include <pjmedia-codec/ffmpeg_codecs.h>
Index: pjproject/trunk/pjmedia/src/test/vid_dev_test.c
===================================================================
--- pjproject/trunk/pjmedia/src/test/vid_dev_test.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/test/vid_dev_test.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjmedia/src/test/vid_port_test.c
===================================================================
--- pjproject/trunk/pjmedia/src/test/vid_port_test.c	(revision 3714)
+++ pjproject/trunk/pjmedia/src/test/vid_port_test.c	(revision 3715)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2009 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2008-2011 Teluu Inc. (http://www.teluu.com)
  * Copyright (C) 2003-2008 Benny Prijono <benny@prijono.org>
  *
Index: pjproject/trunk/pjsip-apps/src/vidgui/vidwin.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/vidgui/vidwin.cpp	(revision 3714)
+++ pjproject/trunk/pjsip-apps/src/vidgui/vidwin.cpp	(revision 3715)
@@ -1,2 +1,20 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
 #include "vidwin.h"
 #include <QEvent>
Index: pjproject/trunk/pjsip-apps/src/vidgui/vidwin.h
===================================================================
--- pjproject/trunk/pjsip-apps/src/vidgui/vidwin.h	(revision 3714)
+++ pjproject/trunk/pjsip-apps/src/vidgui/vidwin.h	(revision 3715)
@@ -1,2 +1,20 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2011 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
 #ifndef VIDWIN_H
 #define VIDWIN_H